package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.util.object.BeanUtils;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodParameterDO;
import com.zt.plat.module.qms.business.config.dal.mapper.ConfigAssayMethodParameterMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.diffList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.*;

/**
 * 检测方法参数配置 Service 实现类
 *
 * @author 后台管理-1
 */
@Service
@Validated
public class ConfigAssayMethodParameterServiceImpl implements ConfigAssayMethodParameterService {

    @Resource
    private ConfigAssayMethodParameterMapper configAssayMethodParameterMapper;

    @Override
    public ConfigAssayMethodParameterRespVO createConfigAssayMethodParameter(ConfigAssayMethodParameterSaveReqVO createReqVO) {
        // 插入
        ConfigAssayMethodParameterDO configAssayMethodParameter = BeanUtils.toBean(createReqVO, ConfigAssayMethodParameterDO.class);
        configAssayMethodParameterMapper.insert(configAssayMethodParameter);
        // 返回
        return BeanUtils.toBean(configAssayMethodParameter, ConfigAssayMethodParameterRespVO.class);
    }

    @Override
    public void updateConfigAssayMethodParameter(ConfigAssayMethodParameterSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigAssayMethodParameterExists(updateReqVO.getId());
        // 更新
        ConfigAssayMethodParameterDO updateObj = BeanUtils.toBean(updateReqVO, ConfigAssayMethodParameterDO.class);
        configAssayMethodParameterMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigAssayMethodParameter(Long id) {
        // 校验存在
        validateConfigAssayMethodParameterExists(id);
        // 删除
        configAssayMethodParameterMapper.deleteById(id);
    }

    @Override
        public void deleteConfigAssayMethodParameterListByIds(List<Long> ids) {
        // 校验存在
        validateConfigAssayMethodParameterExists(ids);
        // 删除
        configAssayMethodParameterMapper.deleteByIds(ids);
        }

    private void validateConfigAssayMethodParameterExists(List<Long> ids) {
        List<ConfigAssayMethodParameterDO> list = configAssayMethodParameterMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_ASSAY_METHOD_PARAMETER_NOT_EXISTS);
        }
    }

    private void validateConfigAssayMethodParameterExists(Long id) {
        if (configAssayMethodParameterMapper.selectById(id) == null) {
            throw exception(CONFIG_ASSAY_METHOD_PARAMETER_NOT_EXISTS);
        }
    }

    @Override
    public ConfigAssayMethodParameterDO getConfigAssayMethodParameter(Long id) {
        return configAssayMethodParameterMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigAssayMethodParameterDO> getConfigAssayMethodParameterPage(ConfigAssayMethodParameterPageReqVO pageReqVO) {
        return configAssayMethodParameterMapper.selectPage(pageReqVO);
    }

}